<?php

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

$template->set_filenames(array('plugins' => PLUGINSMANAGER_PATH . 'template/plugins_new.tpl'));

//------------------------------------------------------automatic installation
if (isset($_GET['revision']) and isset($_GET['extension']) and !is_adviser())
{
  $install_status = $plugins->extract_plugin_files('install', $_GET['revision'], $_GET['extension']);

  redirect($base_url.'&installstatus='.$install_status);
}

//--------------------------------------------------------------install result
if (isset($_GET['installstatus']))
{
  switch ($_GET['installstatus'])
  {
    case 'ok':
      array_push($page['infos'],
        l10n('pm_install_ok'),
        l10n('pm_install_need_activate'));
      break;

    case 'temp_path_error':
      array_push($page['errors'], l10n('pm_temp_path_error'));
      break;

    case 'dl_archive_error':
      array_push($page['errors'], l10n('pm_dl_archive_error'));
      break;

    case 'archive_error':
      array_push($page['errors'], l10n('pm_archive_error'));
      break;

    default:
      array_push($page['errors'],
        sprintf(l10n('pm_extract_error'), $_GET['installstatus']),
        l10n('pm_check_chmod'));
  }  
}

//---------------------------------------------------------------Order options
$order = explode(',', $conf['PluginsManager']);
if (!isset($order[1])) $_GET['order'] = 'date';
if (isset($_GET['order']))
{
	$order[1] = $_GET['order'];
	$query = 'UPDATE ' . CONFIG_TABLE . '
SET value="' . implode(',', $order) . '"
WHERE param="PluginsManager"
LIMIT 1';
  pwg_query($query);
}
$orders = array('date' => l10n('Post date'),
        'revision' => l10n('pm_revision'),
				'name' => l10n('Name'),
				'author' => l10n('Author'));
				
foreach ($orders as $key => $value)
{
    $template->assign_block_vars(
      'order',
        array(
          'DISPLAY' => $value,
          'URL' => htmlentities($base_url) . '&amp;order=' . $key,
          'SELECTED_OPTION' => ($order[1] == $key ? 'SELECTED' : '')));
}

// +-----------------------------------------------------------------------+
// |                     start template output                             |
// +-----------------------------------------------------------------------+
if ($plugins->get_server_plugins(true))
{
  $plugins->sort_server_plugins($order[1]);

  $num = 0;
  foreach($plugins->server_plugins as $plugin)
  {
    $plugin['extension_description'] = utf8_decode($plugin['extension_description']);
    $plugin['revision_description'] = utf8_decode($plugin['revision_description']);

    list($date, ) = explode(' ', $plugin['revision_date']);

    $ver_desc = sprintf(l10n('pm_description'),
			$plugin['revision_name'],
      $date,
      nl2br(htmlspecialchars(strip_tags($plugin['revision_description']))));

    $url_auto_install = htmlentities($base_url)
      . '&amp;revision=' . $plugin['revision_id']
      . '&amp;extension=' . $plugin['extension_id'];

    $template->assign_block_vars('plugins.plugin', array(
      'EXT_NAME' => $plugin['extension_name'],
      'EXT_URL' => PEM_URL.'/extension_view.php?eid='.$plugin['extension_id'],
      'EXT_DESC' => nl2br(htmlspecialchars(strip_tags($plugin['extension_description']))),
      'VERSION' => $plugin['revision_name'],
      'VERSION_URL' => PEM_URL.'/revision_view.php?rid='.$plugin['revision_id'],
      'DATE' => $date,
      'VER_DESC' => $ver_desc,
      'AUTHOR' => $plugin['author_name'],
      'URL_INSTALL' => $url_auto_install,
      'URL_DOWNLOAD' => $plugin['download_url'] . '&amp;origin=piwigo_download',
      'CLASS' => ($num++ % 2 == 1) ? 'row2' : 'row1'));
  }
}
else
{
  array_push($page['errors'], l10n('pm_server_error'));
}
?>