<?php

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

$template->set_filenames(array('plugins' => PLUGINSMANAGER_PATH . 'template/plugins_update.tpl'));

//-----------------------------------------------------------automatic upgrade
if (isset($_GET['plugin']) and isset($_GET['revision']) and !is_adviser())
{
  $plugin_id = $_GET['plugin'];
  $revision = $_GET['revision'];

  if (isset($plugins->db_plugins_by_id[$plugin_id])
    and $plugins->db_plugins_by_id[$plugin_id]['state'] == 'active')
  {
    $plugins->perform_action('deactivate', $plugin_id);

    redirect($base_url
      . '&revision=' . $revision
      . '&plugin=' . $plugin_id
      . '&reactivate=true');
  }

  $upgrade_status = $plugins->extract_plugin_files('upgrade', $revision, $plugin_id);

  if (isset($_GET['reactivate']))
  {
    $plugins->perform_action('activate', $plugin_id);
  }
  redirect($base_url.'&plugin='.$plugin_id.'&upgradestatus='.$upgrade_status);
}

//--------------------------------------------------------------upgrade result
if (isset($_GET['upgradestatus']) and isset($_GET['plugin']))
{
  switch ($_GET['upgradestatus'])
  {
    case 'ok':
      array_push($page['infos'],
         sprintf(
            l10n('pm_upgrade_ok'),
            $plugins->fs_plugins[$_GET['plugin']]['name']));
      break;

    case 'temp_path_error':
      array_push($page['errors'], l10n('pm_temp_path_error'));
      break;

    case 'dl_archive_error':
      array_push($page['errors'], l10n('pm_dl_archive_error'));
      break;

    case 'archive_error':
      array_push($page['errors'], l10n('pm_archive_error'));
      break;

    default:
      array_push($page['errors'],
        sprintf(l10n('plugins_extract_error'), $_GET['upgradestatus']),
        l10n('plugins_check_chmod'));
  }  
}

// +-----------------------------------------------------------------------+
// |                     start template output                             |
// +-----------------------------------------------------------------------+
if ($plugins->get_server_plugins())
{
	$num1 = 0;
	$num2 = 0;
	$num3 = 0;
  foreach($plugins->fs_plugins as $plugin_id => $fs_plugin)
  {
    if (isset($fs_plugin['extension'])
      and isset($plugins->server_plugins[$fs_plugin['extension']]))
    {
      $plugin_info = $plugins->server_plugins[$fs_plugin['extension']];

      list($date, ) = explode(' ', $plugin_info['revision_date']);

      $ver_desc = sprintf(l10n('pm_description'),
        $plugin_info['revision_name'],
        $date,
        utf8_decode(nl2br(htmlspecialchars(strip_tags($plugin_info['revision_description'])))));

      if ($plugins->plugin_version_compare($fs_plugin['version'], $plugin_info['revision_name']))
      {
        // Plugin is up to date
        $template->assign_block_vars('plugins_uptodate.uptodate', array(
          'URL' => $fs_plugin['uri'],
          'NAME' => $fs_plugin['name'],
          'EXT_DESC' => utf8_decode(nl2br(htmlspecialchars(strip_tags($plugin_info['extension_description'])))),
          'VERSION' => $fs_plugin['version'],
          'CLASS' => ($num1++ % 2 == 1) ? 'row2' : 'row1'));
      }
      else
      {
        // Plugin need upgrade
        $url_auto_update = $base_url
          . '&amp;revision=' . $plugin_info['revision_id']
          . '&amp;plugin=' . $plugin_id;

        $template->assign_block_vars('plugins_not_uptodate.not_uptodate', array(
          'EXT_NAME' => $fs_plugin['name'],
          'EXT_URL' => $fs_plugin['uri'],
          'EXT_DESC' => utf8_decode(nl2br(htmlspecialchars(strip_tags($plugin_info['extension_description'])))),
          'VERSION' => $fs_plugin['version'],
          'VERSION_URL' => PEM_URL.'/revision_view.php?rid='.$plugin_info['revision_id'],
          'NEW_VERSION' => $plugin_info['revision_name'],
          'NEW_VER_DESC' => $ver_desc,
          'URL_UPDATE' => $url_auto_update,
          'URL_DOWNLOAD' => $plugin_info['download_url'] . '&amp;origin=piwigo_download',
          'CLASS' => ($num2++ % 2 == 1) ? 'row2' : 'row1'));
      }
    }
    else
    {
      // Can't check plugin
      $template->assign_block_vars('plugins_cant_check.cant_check', array(
        'NAME' => $fs_plugin['name'],
        'VERSION' => $fs_plugin['version'],
        'CLASS' => ($num3++ % 2 == 1) ? 'row2' : 'row1'));
    }
  }
}
else
{
  array_push($page['errors'], l10n('pm_server_error'));
}
?>